-- Test media_path
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(10);

set search_path to camper, public;

select has_function('camper', 'path', array['media']);
select function_lang_is('camper', 'path', array['media'], 'sql');
select function_returns('camper', 'path', array['media'], 'text');
select isnt_definer('camper', 'path', array['media']);
select volatility_is('camper', 'path', array['media'], 'stable');
select function_privs_are('camper', 'path', array['media'], 'guest', array['EXECUTE']);
select function_privs_are('camper', 'path', array['media'], 'employee', array['EXECUTE']);
select function_privs_are('camper', 'path', array['media'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'path', array['media'], 'authenticator', array[]::text[]);

set client_min_messages to warning;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ff0000","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","b c #00ff00","b"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","c c #0000ff","c"};')
     , ('image/svg+xml', '<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>')
     , ('text/plain', 'hello, world!')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (3, 1, 'cover1.xpm', sha256('static char *s[]={"1 1 1 1","a c #ff0000","a"};'))
     , (4, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","b c #00ff00","b"};'))
     , (5, 1, 'cover3.xpm', sha256('static char *s[]={"1 1 1 1","c c #0000ff","c"};'))
     , (6, 1, 'image.svg', sha256('<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>'))
     , (7, 1, 'text.txt', sha256('hello, world!'))
;

select bag_eq(
	$$ select media_id, media.path from media order by media_id $$,
	$$ values (3, '/media/fbbac389f80d12ef13a3dd6e5dec9541622b7f870f22cfa94c3ca374d6dbc6b4/cover1.xpm')
	        , (4, '/media/b1ac118723104963266ceff35cc5170802885412d1bc6ea247981c15eb4b00b1/cover2.xpm')
	        , (5, '/media/72ccd5c651416d714740715035e0e099c18785ce9f9a8f4222bfb72f663b1c18/cover3.xpm')
	        , (6, '/media/ffc9f5e4fdeea83920c171e2bd17577127c5d1a2c3c76f07440e10d387132280/image.svg')
	        , (7, '/media/68e656b251e67e8358bef8483ab0d51c6619f3e7a1a9f0e75838d41ff368f728/text.txt')
	$$,
	'Should give out the URL path for each media'
);

select *
from finish();

rollback;
